#ifndef __MPLAYER_MEMCPY
#define __MPLAYER_MEMCPY 1

#include "mp3_config.h"

#ifdef USE_FASTMEMCPY
#include <stddef.h>

extern void *(*fastmemcpy_func)(void * to, const void * from, size_t len);
extern void *(*mem2agpcpy_func)(void * to, const void * from, size_t len);
//extern void * fast_memcpy(void * to, const void * from, size_t len);
//extern void * mem2agpcpy(void * to, const void * from, size_t len);
#define memcpy(a,b,c) (fastmemcpy_func)(a,b,c)
#define mem2agpcpy(a,b,c) (mem2agpcpy_func)(a,b,c)

#endif

static inline void * mem2agpcpy_pic(void * dst, void * src, int bytesPerLine, int height, int dstStride, int srcStride)
{
	int i;
	void *retval=dst;

	if(dstStride == srcStride) mem2agpcpy(dst, src, srcStride*height);
	else
	{
		for(i=0; i<height; i++)
		{
			mem2agpcpy(dst, src, bytesPerLine);
			src+= srcStride;
			dst+= dstStride;
		}
	}

	return retval;
}

static inline void * memcpy_pic(void * dst, void * src, int bytesPerLine, int height, int dstStride, int srcStride)
{
	int i;
	void *retval=dst;

	if(dstStride == srcStride) memcpy(dst, src, srcStride*height);
	else
	{
		for(i=0; i<height; i++)
		{
			memcpy(dst, src, bytesPerLine);
			src+= srcStride;
			dst+= dstStride;
		}
	}

	return retval;
}

#endif
