// separated from sr1.c

#include "mpg123engine.h"
#include "bswap.h"

unsigned int getbits(short number_of_bits)
{
  unsigned long rval;
//  if(MP3_frames>=7741) printf("getbits: bits=%d  bsi.bitsleft=%d  wordptr=%x\n",number_of_bits,bsi.bitsleft,bsi.wordpointer);
  if((bsi.bitsleft-=number_of_bits)<0) return 0;
  if(!number_of_bits) return 0;
         rval = bsi.wordpointer[0];
         rval <<= 8;
         rval |= bsi.wordpointer[1];
         rval <<= 8;
         rval |= bsi.wordpointer[2];
         rval <<= bsi.bitindex;
         rval &= 0xffffff;
         bsi.bitindex += number_of_bits;
         rval >>= (24-number_of_bits);
         bsi.wordpointer += (bsi.bitindex>>3);
         bsi.bitindex &= 7;
  return rval;
}


unsigned int getbits_fast(short number_of_bits)
{
  unsigned long rval;
//  if(MP3_frames>=7741) printf("getbits_fast: bits=%d  bsi.bitsleft=%d  wordptr=%x\n",number_of_bits,bsi.bitsleft,bsi.wordpointer);
  if((bsi.bitsleft-=number_of_bits)<0) return 0;
  if(!number_of_bits) return 0;
#if defined(CAN_COMPILE_X86_ASM)
  rval = bswap_16(*((unsigned short *)bsi.wordpointer));
#else
  /*
   * we may not be able to address unaligned 16-bit data on non-x86 cpus.
   * Fall back to some portable code.
   */
  rval = bsi.wordpointer[0] << 8 | bsi.wordpointer[1];
#endif
         rval <<= bsi.bitindex;
         rval &= 0xffff;
         bsi.bitindex += number_of_bits;
         rval >>= (16-number_of_bits);
         bsi.wordpointer += (bsi.bitindex>>3);
         bsi.bitindex &= 7;
  return rval;
}

unsigned int get1bit(void)
{
  unsigned char rval;
//  if(MP3_frames>=7741) printf("get1bit: bsi.bitsleft=%d  wordptr=%x\n",bsi.bitsleft,bsi.wordpointer);
  if((--bsi.bitsleft)<0) return 0;
  rval = *bsi.wordpointer << bsi.bitindex;
  bsi.bitindex++;
  bsi.wordpointer += (bsi.bitindex>>3);
  bsi.bitindex &= 7;
  return ((rval>>7)&1);
}

void set_pointer(long backstep)
{
//  if(backstep!=512 && backstep>mp.fsizeold)
//    printf("\rWarning! backstep (%d>%d)                                         \n",backstep,mp.fsizeold);
  bsi.wordpointer = mp.bsbuf + mp.ssize - backstep;
  if (backstep) memcpy(bsi.wordpointer,mp.bsbufold+mp.fsizeold-backstep,backstep);
  bsi.bitindex = 0;
  bsi.bitsleft+=8*backstep;
//  printf("Backstep %d  (bsi.bitsleft=%d)\n",backstep,bsi.bitsleft);
}

