/* MP3 Player Library 2.0      (C) 1999 A'rpi/Astral&ESP-team  */

struct id3tag {
   char title[31];
   char artist[31];
   char album[31];
   char year[5];
   char comment[31];
   char genre[31];
};

struct MP3Info_t {
   int eof;        // set if EOF reached
   int pause;      // lock playing
   int filesize;   // filesize
   int frames;     // current frame no
   int fpos;       // current file pos
   int framesize;  // current framesize in bytes (including header)
   int bitrate;    // current bitrate (kbits)
   int samplerate; // current sampling freq (Hz)
   int channels;
   int bps;
   int length;     // song_time
   int has_tag;
   struct id3tag tag1;
};
extern struct MP3Info_t MP3Info;

extern FILE* mp3_file;

/* decoder level: */
#ifdef USE_FAKE_MONO
extern void MP3_Init(int fakemono);
#else
extern void MP3_Init();
#endif
extern void MP3_SeekFrame(int num,int dir);
extern void MP3_SeekForward(int num);
extern int MP3_DecodeFrame(unsigned char *hova,short single);
extern int MP3_FillBuffers();
extern void MP3_PrintHeader();

extern int MP3_Open(char *filename,int buffsize);
extern void MP3_Close();
extern int MP3_PrintTAG();

/* public variables: */

/* player level: */
extern int  MP3_OpenDevice(char *devname);  /* devname can be NULL for default) */
extern void MP3_Play();
extern void MP3_Stop();
extern void MP3_CloseDevice();

enum 
{
   DECODE_TEST, DECODE_AUDIO, DECODE_FILE, DECODE_BUFFER, DECODE_WAV, DECODE_AU, DECODE_CDR, DECODE_AUDIOFILE 
};


#ifdef USE_FAKE_MONO
extern void MP3_set_synth_functions(int accel, int fakemono);
#else
extern void MP3_set_synth_functions(int accel);
#endif

#ifndef USE_FASTMEMCPY
#define mem2agpcpy(a,b,c) memcpy(a,b,c)
#define fast_memcpy(a,b,c) memcpy(a,b,c)
#endif

extern int MP3_GetSongInfo(struct MP3Info_t *mi, char *filename);

extern int (*audio_read)(char *buf,int size);

