# if you want to build with automated optimal CFLAGS by x86cpucaps, set to 1
%define x86autoopt    1

%define _with_esd     1
%define _with_xmms    1

# if you want to build with jconv(Japanese Code Conversion), set to 1
%define _with_jconv   0

Packager: Osamu Kayasono <jacobi@jcom.home.ne.jp>
Summary: SSE/3DNow!/MMX optimized MP3 decoding library 
Name: mp3lib
Version: 0.2.1
Release: 1ok
License: GPL
Group: System Environment/Libraries
Source: %{name}-%{version}.tar.gz
BuildPrereq: sed
%if %{_with_esd}
BuildPrereq: esound-devel
Requires: esound
%endif
%if %{_with_xmms}
BuildPrereq: xmms-devel
Requires: xmms
%endif
%if %{_with_jconv}
BuildPrereq: libjconv
Requires: libjconv
%endif
Prefix: /usr
BuildRoot: %{_tmppath}/%{name}-%{version}

%description
mp3lib is a mp3 decoding library, based on MPlayer-0.90pre7.
It supports SIMD instructions (SSE/MMX/3DNow!Ex/3DNow!).

%package -n mp3dec
Summary: tiny MP3 player
Group: Applications/Multimedia
Requires: mp3lib = %{version}

%description -n mp3dec
tiny MP3 player using mp3lib.

%package xmms
Summary: XMMS input plugin
Group: Applications/Multimedia
Requires: mp3lib = %{version}

%description xmms
XMMS input plugin using mp3lib.

%prep
%setup -q -n %{name}

%build
EXTFLAGS="-finline-functions -fomit-frame-pointer -funroll-all-loops -ffast-math"
CFLAGS="$RPM_OPT_FLAGS $EXTFLAGS"
CXXFLAGS="$CFLAGS"
FFLAGS="$CFLAGS"
export CFLAGS CXXFLAGS FFLAGS

## optimal CFLAGS with x86cpucaps
%if %{x86autoopt}
if [ -x /usr/bin/cpucaps ]; then
   GCCVER=`gcc -dumpversion`
   CFLAGS="-O3 `cpucaps -g -w $GCCVER`"
   CFLAGS="$CFLAGS $EXTFLAGS"
   CXXFLAGS="$CFLAGS"; FFLAGS="$CFLAGS"; RPM_OPT_FLAGS="$CFLAGS"
   export CFLAGS CXXFLAGS FFLAGS RPM_OPT_FLAGS
fi
%endif

%if %{_with_jconv}
sed 's/USE_JCONV.*/USE_JCONV = yes/' config.mak > config.tmp
cp -f config.tmp config.mak
%endif
%if %{_with_esd}
sed 's/USE_ESD.*/USE_ESD = yes/' config.mak > config.tmp
cp -f config.tmp config.mak
%endif
%if %{_with_xmms}
sed 's/WITH_XMMS_PLUGIN.*/WITH_XMMS_PLUGIN = yes/' config.mak > config.tmp
cp -f config.tmp config.mak
%endif

make OPTFLAGS="$RPM_OPT_FLAGS"

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make install DESTDIR=${RPM_BUILD_ROOT}

%if %{_with_xmms}
xmms-config --input-plugin-dir > filelist.xmms
%endif


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc COPYING README ChangeLog
%{prefix}/lib/*.so.*
%{prefix}/lib/*.so
%{prefix}/include/*.h

%files -n mp3dec
%defattr(-,root,root)
%{prefix}/bin/*

%if %{_with_xmms}
%files xmms -f filelist.xmms
%defattr(-,root,root)
%endif
