#include <stdio.h>
#include <stdlib.h>

#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/soundcard.h>

#ifdef USE_JCONV
#include "jconv.h"
#endif

#ifdef USE_SDL
#include <SDL/SDL.h>
#endif

#include "mp3.h"
#include "mp3_config.h"

#include "mpg123engine.h"

#include "player.h"
#include "playlist.h"
#include "getlopt.h"

struct parameter param;
static char *listname = NULL;

static void usage(char *);
static void print_title(void);


FILE* MP3_file=NULL;

void play_mp3file(char *);
int mplayer_audio_read(char *buf,int size){
    return fread(buf,1,size,MP3_file);
}

#include <sys/time.h>
static inline long GetTimer()
{
   struct timeval tv;
   struct timezone tz;
   gettimeofday(&tv,&tz);
   return (long)(tv.tv_sec*1000000+tv.tv_usec);
};



#ifdef USE_SDL

// Samplesize used by the SDLlib AudioSpec struct
# define SAMPLESIZE 1024
# define BUFFSIZE 4096
# define NUM_BUFS 16 
// General purpose Ring-buffering routines
static unsigned char *buffer[NUM_BUFS];

static unsigned int buf_read=0;
static unsigned int buf_write=0;
static unsigned int buf_read_pos=0;
static unsigned int buf_write_pos=0;
static unsigned int volume=127;
static int full_buffers=0;
static int buffered_bytes=0;

SDL_AudioSpec aspec;

void outputaudio(void *unused, Uint8 *stream, int len);
void mixaudio(void *unused, Uint8 *stream, int len);
static int read_buffer(unsigned char* data,int len);

#endif /* USE_SDL */

/* Please note: GLO_NUM expects point to LONG! */
topt opts[] = {
//    {'k', "skip",        GLO_ARG | GLO_LONG, 0, &param.startFrame, 0},
//    {'a', "audiodevice", GLO_ARG | GLO_CHAR, 0, &ai.device,  0},
//    {'2', "2to1",        0,                  0, &param.down_sample, 1},
//    {'4', "4to1",        0,                  0, &param.down_sample, 2},
    {'t', "test",        0,                  0, &param.outmode, DECODE_TEST},
//    {'s', "stdout",      0,       SetOutStdout, &param.outmode, DECODE_FILE},
//    {'S', "STDOUT",      0,       SetOutStdout1, &param.outmode, DECODE_AUDIOFILE},
//    {'O', "outfile",     GLO_ARG | GLO_CHAR, SetOutFile, NULL, 0},
//    {'c', "check",       0,                  0, &param.checkrange, TRUE},
///    {'v', "verbose",     0,        set_verbose, 0,           0},
//    {'q', "quiet",       0,                  0, &param.quiet,      TRUE},
//    {'y', "resync",      0,                  0, &param.tryresync,  FALSE},
#ifdef USE_FAKE_MONO
    {'1',   "left",        0,                  0, &param.force_mono, 1},
    {'2',   "right",       0,                  0, &param.force_mono, 2},
#endif
    {0,   "stereo",      0,                  0, &param.force_stereo, 1},
//    {0,   "reopen",      0,                  0, &param.force_reopen, 1},
//    {'g', "gain",        GLO_ARG | GLO_LONG, 0, &ai.gain,    0},
    {'r', "rate",        GLO_ARG | GLO_LONG, 0, &param.force_rate,  0},
//    {0  , "pitch",       GLO_ARG | GLO_FLOAT,0, &param.pitch     ,  0},
    {0,   "8bit",        0,                  0, &param.force_8bit, 1},
//    {0,   "headphones",  0,                  set_output_h, 0,0},
//    {0,   "speaker",     0,                  set_output_s, 0,0},
//    {0,   "lineout",     0,                  set_output_l, 0,0},
//    {'o', "output",      GLO_ARG | GLO_CHAR, set_output, 0,  0},
//    {'f', "scale",       GLO_ARG | GLO_LONG, 0, &param.outscale,   0},
//    {'n', "frames",      GLO_ARG | GLO_LONG, 0, &numframes,  0},
//#ifdef TERM_CONTROL
//    {'C', "control",	 0,		     0, &param.term_ctrl, TRUE},
//#endif
//    {'b', "buffer",      GLO_ARG | GLO_LONG, 0, &param.usebuffer,  0},
//    {'R', "remote",      0,                  0, &param.remote,     FRONTEND_GENERIC},
    {'R', "remote",      0,                  0, &param.remote,     3},
//    {'d', "doublespeed", GLO_ARG | GLO_LONG, 0, &param.doublespeed,0},
//    {'h', "halfspeed",   GLO_ARG | GLO_LONG, 0, &param.halfspeed,  0},
//    {'p', "proxy",       GLO_ARG | GLO_CHAR, 0, &proxyurl,   0},
    {'@', "list",        GLO_ARG | GLO_CHAR, 0, &listname,   0},
    /* 'z' comes from the the german word 'zufall' (eng: random) */
    {'z', "shuffle",     0,                  0, &param.shuffle,    1},
    {'Z', "random",      0,                  0, &param.shuffle,    2},
//    {'E', "equalizer",	 GLO_ARG | GLO_CHAR, 0, &param.equalfile,1},
//    {0,   "aggressive",	 0,   	             0, &param.aggressive,2},
    {0,   "force-3dnowex", 0,                0, &param.simd_select,MODE_3DNOWEXT},
    {0,   "force-3dnow", 0,                  0, &param.simd_select,MODE_3DNOW},
    {0,   "force-sse", 0,                  0, &param.simd_select,MODE_SSE},
    {0,   "force-mmx",   0,                  0, &param.simd_select,MODE_MMX},
    {0,   "force-fpu",   0,                  0, &param.simd_select,MODE_FPU},
    {0,   "test-simd",   0,                  0, &param.test_simd,TRUE},
//#if !defined(WIN32) && !defined(GENERIC)
//    {'u', "auth",        GLO_ARG | GLO_CHAR, 0, &httpauth,   0},
//#endif
//#if defined(SET_RT)
//    {'T', "realtime",   0,                  0, &param.realtime, TRUE },
//#else
//    {'T', "realtime",   0,       not_compiled, 0,           0 },    
//#endif
//    {0  , "title",	0,		0, &param.xterm_title, TRUE },
//    {'w', "wav",        GLO_ARG | GLO_CHAR, set_wav, 0 , 0 },
//    {0  , "cdr",        GLO_ARG | GLO_CHAR, set_cdr, 0 , 0 },
//    {0  , "au",         GLO_ARG | GLO_CHAR, set_au,  0 , 0 },
//    {0  , "longhelp",   0,        usage,  0,           0 },
    {'?', "help",       0,        usage, 0,           0 },
    {'v', "version",    0,                     0, &param.print_version,1},
//#ifdef USE_ESD
//    {0 , "esd",     GLO_ARG | GLO_CHAR,    0,  &param.esdserver, 0 },
//#endif
    {0, 0, 0, 0, 0, 0}
};


#define ABUFFLEN 16384
#//4608
struct mp3dat_s 
{
   char *fname;
   int len;
   long total;
   float length;
   int filesize;
   int samplerate;
   int channels;

   unsigned char audiobuf[ABUFFLEN];


   long time1;
   int audio_fd;
};
struct mp3dat_s mp3dat;


static int OpenFile(char *fname)
{
   int r;
   
DBGMSG1("Openfile\n");
   memset(&mp3dat,0,sizeof (struct mp3dat_s));
   
//   mp3dat.total =0;
   mp3dat.time1 = GetTimer();
   
   mp3dat.filesize=MP3_Open(fname, ABUFFLEN); // MP3_Open included mp3_init()
   if(mp3dat.filesize==0){  printf("file not found : %s\n", fname);  return 1; }

   mp3dat.fname=fname;
   mp3dat.len=MP3_DecodeFrame(mp3dat.audiobuf,-1); // get channels, samplerate, etc.

   mp3dat.samplerate = MP3_samplerate; // audio freqs in samples-per-second
   mp3dat.channels = MP3_channels; // mono/stereo

#ifdef USE_SDL
   if (SDL_Init(SDL_INIT_AUDIO)) 
     {
	printf("SDL: Initializing of SDL Audio Failed: %s\n", SDL_GetError());
	return 1;
     }
   aspec.format = AUDIO_S16LSB; // see SDL_audio.h
   aspec.freq = mp3dat.samplerate; // audio freqs in samples-per-second
   aspec.channels = mp3dat.channels; // mono/stereo
   aspec.samples = SAMPLESIZE;
   aspec.callback = outputaudio; //outputaudio;
   aspec.userdata = NULL;
   if (SDL_OpenAudio(&aspec, NULL) <0) 
     {
	printf("SDL: Unable to open audio: %s\n", SDL_GetError());
	return 1;
     }
   SDL_PauseAudio(0);
#else
   mp3dat.audio_fd=open("/dev/dsp", O_WRONLY); // open audio device
   if(mp3dat.audio_fd<0){  printf("Can't open audio device\n"); return 1; }
   r=AFMT_S16_LE;ioctl (mp3dat.audio_fd, SNDCTL_DSP_SETFMT, &r);
   r=MP3_channels-1;ioctl (mp3dat.audio_fd, SNDCTL_DSP_STEREO, &r);
   r=MP3_samplerate;ioctl (mp3dat.audio_fd, SNDCTL_DSP_SPEED, &r);
DBGMSG1(" audio_setup: using %d Hz samplerate (requested: %d)\n",r,MP3_samplerate);
#endif   
   
   return 0;
}

static void CloseFile()
{
DBGMSG1("Closefile\n");
#ifdef USE_SDL
   SDL_CloseAudio();
   SDL_Quit();
#else
   close(mp3dat.audio_fd); // close audio device
#endif
   MP3_Close();
}


static void PlayFile()
{
   int r;
//   unsigned int time1;
   long time1;
#ifdef USE_SDL
   int channels;
#endif

DBGMSG1("Playfile\n");
   printf(" Playing MPEG stream from %s\n\n", mp3dat.fname);
   
#ifdef USE_SDL
   printf("ch=%d, rate=%d\n", mp3dat.channels,mp3dat.samplerate);
   if (param.outmode != DECODE_TEST) {
      while (SDL_GetAudioStatus()==SDL_AUDIO_PLAYING) {
	 SDL_LockAudio();
	 SDL_UnlockAudio();
	 sleep(mp3dat.filesize);
	 printf("mosikasite kokode loop siteru?\n");
      };
#else      
   if (param.outmode != DECODE_TEST) {
// --- normal decoding mode      
// audio setup
      while(1){
	 int len2;
	 if(mp3dat.len==0) mp3dat.len=MP3_DecodeFrame(mp3dat.audiobuf,-1);
	 if(mp3dat.len<=0) break; // EOF
      
	 // play it
	 len2=write(mp3dat.audio_fd,mp3dat.audiobuf,mp3dat.len);
	 if(len2<0) break; // ERROR?
	 mp3dat.len-=len2; mp3dat.total+=len2;
	 if(mp3dat.len>0){
	    // this shouldn't happen...
	    memcpy(mp3dat.audiobuf,mp3dat.audiobuf+len2,mp3dat.len);
	    putchar('!');fflush(stdout);
	 }
      }
#endif   /* USE_SDL */   
   } else {
// test mode       
//	while((mp3dat.len=MP3_DecodeFrame(audiobuf,-1))>0 && mp3dat.total<2000000){
      while((mp3dat.len=MP3_DecodeFrame(mp3dat.audiobuf,-1))>0){
	 mp3dat.total+=mp3dat.len;
	 // play it
	 // /* DUMP_PCM */ fwrite(audiobuf,mp3dat.len,1,f);
	 //putchar('.');fflush(stdout);
      }
   }

   printf("Decoding of %s finished.\n", mp3dat.fname);
   
   if (param.outmode == DECODE_TEST) {
      time1 = GetTimer() - time1;
      mp3dat.length=(float)mp3dat.total/(float)(MP3_samplerate*MP3_channels*2);
      printf("\nDecoding time: %8.6f\n",(float)time1*0.000001f);
      printf("Uncompressed size: %d bytes  (%8.3f secs)\n",mp3dat.total,mp3dat.length);
      printf("CPU usage at normal playback: %5.2f %\n",time1*0.0001f/mp3dat.length);
   }
//   free(audiobuf);
}

#ifdef USE_SDL
#define NUM_SOUNDS 2
struct sample {
   Uint8 *data;
   Uint32 dpos;
   Uint32 dlen;
} sounds[NUM_SOUNDS];
void mixaudio(void *unused, Uint8 *stream, int len) {
   int i;
   Uint32 amount;
   
   for (i=0;i<NUM_SOUNDS; ++i) 
     {
	amount = (sounds[i].dlen-sounds[i].dpos);
	if (amount >len) amount = len;
	SDL_MixAudio(stream, &sounds[i].data[sounds[i].dpos], amount, SDL_MIX_MAXVOLUME);
	sounds[i].dpos += amount;
     }
}
// SDL Callback function
void outputaudio(void *unused, Uint8 *stream, int len) {
   //SDL_MixAudio(stream, read_buffer(buffers, len), len, SDL_MIX_MAXVOLUME);
	//if(!full_buffers) printf("SDL: Buffer underrun!\n");

//	read_buffer(stream, len);
	//printf("SDL: Full Buffers: %i\n", full_buffers);
//   return;
   
   Uint32 amount;
   int readlength;
   
//   if (readlength>BUFFSIZE)
//     readlength=BUFFSIZE;
//   else
     {
	readlength=MP3_DecodeFrame(mp3dat.audiobuf,-1);
printf("filesize=%d, len=%d, readlen=%d, amount=%d\n", mp3dat.filesize,len, readlength,amount);
	
//	memcpy(mp3dat.audiobuf+readlength, mp3dat.audiobuf+readlength,x);
	SDL_MixAudio(stream, mp3dat.audiobuf, readlength, param.volume);
	mp3dat.dpos += amount;
     }
   
}

static int read_buffer(unsigned char* data,int len){
  int len2=0;
  int x;
printf("read_buffer\n");   
  while(len>0){
    if(full_buffers==0) break; // no more data buffered!
    x=BUFFSIZE-mp3dat.dpos;
     if(mp3dat.len==0) mp3dat.len=MP3_DecodeFrame(mp3dat.audiobuf,-1);
    if(x>len) x=len;
//    memcpy(data+len2,buffer[buf_read]+mp3dat.dpos,x);
    memcpy(data+len2,mp3dat.audiobuf+mp3dat.dpos,x);
    SDL_MixAudio(data+len2, data+len2, x, param.volume);
    len2+=x; len-=x;
    buffered_bytes-=x; mp3dat.dpos+=x;
//    if(mp3dat.dpos>=BUFFSIZE){
//       // block is empty, find next!
//       buf_read=(buf_read+1)%NUM_BUFS;
//       --full_buffers;
//       mp3dat.dpos=0;
//    }
  }
  return len2;
}
#endif 
   
int main(int argc,char* argv[]){
//  char inpbuf[3];
   
   int result;
   struct playlist *playlist;
   param.simd_select = MODE_AUTO;
   param.outmode = DECODE_AUDIO;
   param.force_mono = 0;
   param.volume = 127;
#ifdef USE_SDL
   param.volume = SDL_MIX_MAXVOLUME;
#endif   
   char *fname, *dummy;
   
   while ( (result = getlopt(argc, argv, opts)) != GLO_END) {
      switch(result)
	{
	 case GLO_UNKNOWN:
	   exit (1);
	 case GLO_NOARG:
	   exit (1);
	}
   }
  if (param.print_version) 
     {
	fprintf(stderr,"Version %s\n", VERSION);
	exit (0);
     }
		
   DBGMSG0("simd_select=%d, shuffule=%d\n",param.simd_select,param.shuffle);

   // MPEG Audio init:
#ifdef USE_FAKE_MONO
  MP3_Init(param.force_mono);
  if (param.simd_select != MODE_AUTO) set_synth_functions(param.simd_select,param.force_mono);
#else
  MP3_Init();
  if (param.simd_select != MODE_AUTO) set_synth_functions(param.simd_select);
#endif
   
   playlist = new_playlist(argc, argv, listname, loptind);
   if ((!playlist) || (playlist->shuffle_listsize == 0) ) 
     {
	usage(dummy);
	exit (1);
     }
   
   print_title();
   
   // begin of Loop Playing files
   while (fname = playlist->next(playlist)) 
     {
	if (!*fname || !strcmp(fname, "-"))
	  fname = NULL;
	else
	  {
	     if (OpenFile(fname)==0) 
	       {
		  PlayFile();
		  CloseFile();
	       }
	  }
     }

// end of Loop Playing files
}


static void print_title(void)
{
    fprintf(stderr,"MP3 player, %s version %s\n", PACKAGE,VERSION);
}

static void usage(char *d)
{
    FILE *o = stderr;

    print_title();
    fprintf(stderr,"\nusage: %s [option(s)] [file(s) | URL(s) | -]\n", PACKAGE);
    fprintf(stderr,"supported options:\n\n");
//    fprintf(o,"\n -k <n> --skip <n>         \n");
//    fprintf(o," -a <f> --audiodevice <f>  \n");
//    fprintf(o," -2     --2to1             2:1 Downsampling\n");
//    fprintf(o," -4     --4to1             4:1 Downsampling\n");
    fprintf(o," -t     --test             \n");
//    fprintf(o," -s     --stdout           \n");
//    fprintf(o," -S     --STDOUT           Play AND output stream (not implemented yet)\n");
//    fprintf(o," -c     --check            \n");
//    fprintf(o," -v[*]  --verbose          Increase verboselevel\n");
//    fprintf(o," -q     --quiet            Enables quiet mode\n");
//    fprintf(o,"        --title            Prints filename in xterm title bar\n"),
//    fprintf(o," -y     --resync           DISABLES resync on error\n");
    fprintf(o," -1     --left             Play only left channel\n");
    fprintf(o," -2     --right            Play only right channel\n");
//    fprintf(o," -m     --mono --mix       Mix stereo to mono\n");
//    fprintf(o,"        --stereo           Duplicate mono channel\n");
//    fprintf(o,"        --reopen           Force close/open on audiodevice\n");
//    fprintf(o," -g     --gain             Set audio hardware output gain\n");
//    fprintf(o," -r     --rate             Force a specific audio output rate\n");
//    fprintf(o,"        --pitch <p>        Pitchs the output by factor <p>\n");
//    fprintf(o,"        --8bit             Force 8 bit output\n");
//    fprintf(o," -o h   --headphones       Output on headphones\n");
//    fprintf(o," -o s   --speaker          Output on speaker\n");
//    fprintf(o," -o l   --lineout          Output to lineout\n");
//    fprintf(o," -f <n> --scale <n>        Scale output samples (soft gain)\n");
//    fprintf(o," -n     --frames <n>       Play only <n> frames of every stream\n");
 //   fprintf(o," -b <n> --buffer <n>       Set play buffer (\"output cache\")\n");
//#if 0
//    fprintf(o," -R     --remote		Generic remote interface\n");
//#endif
//    fprintf(o," -d     --doublespeed      Play only every second frame\n");
//    fprintf(o," -h     --halfspeed        Play every frame twice\n");
//    fprintf(o," -p <f> --proxy <f>        Set WWW proxy\n");
//    fprintf(o," -@ <f> --list <f>         Play songs in <f> file-list\n");
    fprintf(o," -z     --shuffle          Shuffle song-list before playing\n");
    fprintf(o," -Z     --random           full random play\n");
//    fprintf(o," -E <f> --equalizer <f>    Exp.: scales freq. bands acrd. to values in file <f>\n");
//    fprintf(o,"        --aggressive       Tries to get higher priority (nice)\n");
//    fprintf(o," -u     --auth             Set auth values for HTTP access\n");
//    fprintf(o," -w <f> --wav <f>          Writes samples as WAV file in <f> (- is stdout)\n");
//    fprintf(o,"        --au <f>           Writes samples as Sun AU file in <f> (- is stdout)\n");
//    fprintf(o,"        --cdr <f>          Writes samples as CDR file in <f> (- is stdout)\n");
//    fprintf(o,"        --test-simd        Display result of SIMD capability and exit\n");
    fprintf(o,"        --force-3dnowex    Force use of 3DNowEx! optimized routine\n");
    fprintf(o,"        --force-3dnow      Force use of 3DNow! optimized routine\n");
    fprintf(o,"        --force-sse        Force use of SSE optimized routine\n");
    fprintf(o,"        --force-mmx        Force use of MMX optimized routine\n");
    fprintf(o,"        --force-fpu        Force use of floating-pointer routine\n");
    fprintf(o," -v     --version          Prints version and exit\n");
//#ifdef USE_ESD
//    fprintf(o,"        --esd <s>          Plays to  ESD server <s> \n");
//#endif
//    fprintf(o,"\nSee the manpage %s(1) for more information.\n", PACKAGE);
    exit(0);
}


